import requests
import time

token = '********-****-****-****-***********'
X_start = 21
Y_start = 5
X_max = 236
Y_max = 253

X_rows = 16
Y_rows = 19


X_diff = (X_max - X_start) // X_rows
Y_diff = (Y_max - Y_start) // Y_rows

init_wait_seconds = 15
wait_seconds = 3

IP_snapmaker = '192.***.***.***'
port_snapmaker = 8080

IP_ESPDRO = '192.***.***.***'
port_ESPDRO = 80

Lift_Dial = True;
Lift_Dist = 3

save_file = 'data.txt'

'''
http://192.168.117.115:8080/api/v1/execute_code
POST
token=
Code=G91

http://192.168.117.115:8080/api/v1/execute_code
POST
token=
Code=G0 Z1 F1500

http://192.168.117.115:8080/api/v1/execute_code
POST
token=
Code=G90
'''


post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G90"
#print(post_request)
r = requests.post(post_request)
#print(r.status_code)

result = []

n = 0
#print(range((X_max - X_start) // X_diff))
#print(range((Y_max - Y_start) // Y_diff))

if Lift_Dial == True:
    post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G91"
    #print(post_request)
    requests.post(post_request)
    
    post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G0 Z+" + str(Lift_Dist) + " F1500"
    #print(post_request)
    requests.post(post_request)
    
    post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G90"
    #print(post_request)
    requests.post(post_request)

post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G0 X" + str(X_start) + " Y" + str(Y_start) + " F1500"
#print(post_request)
r = requests.post(post_request)
#print(r.status_code)

if Lift_Dial == True:
    post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G91"
    #print(post_request)
    requests.post(post_request)
    
    post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G0 Z-" + str(Lift_Dist) + "  F1500"
    #print(post_request)
    requests.post(post_request)
    
    post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G90"
    #print(post_request)
    requests.post(post_request)

time.sleep(init_wait_seconds)

print(" - START CSV - ")
print("X(mm);Y(mm);Z(µm)")
for i in range((X_max - X_start) // X_diff):
  looping = range((Y_max - Y_start) // Y_diff)
  if (i % 2) == 1:
    looping = reversed(range((Y_max - Y_start) // Y_diff))
  for j in looping:
    n = n+1
    X_coord = X_start + i * X_diff
    Y_coord = Y_start + j * Y_diff

    if Lift_Dial == True:
        post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G91"
        #print(post_request)
        requests.post(post_request)
        
        post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G0 Z+" + str(Lift_Dist) + " F1500"
        #print(post_request)
        requests.post(post_request)
        
        post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G90"
        #print(post_request)
        requests.post(post_request)

    post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G0 X" + str(X_coord) + " Y" + str(Y_coord) + " F1500"
    #print(post_request)
    r = requests.post(post_request)
    #print(r.status_code)

    if Lift_Dial == True:
        post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G91"
        #print(post_request)
        requests.post(post_request)
        
        post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G0 Z-" + str(Lift_Dist) + "  F1500"
        #print(post_request)
        requests.post(post_request)
        
        post_request = "http://" + IP_snapmaker + ":" + str(port_snapmaker) + "/api/v1/execute_code?token=" + token + "&code=G90"
        #print(post_request)
        requests.post(post_request)

    time.sleep(wait_seconds)
    
    get_request = "http://" + IP_ESPDRO + "/peek"
    z = requests.get(get_request)
    #print(z.status_code)
    #print(z.text)

    result.append((X_coord, Y_coord, z.text))
    print(str(X_coord) + ";" + str(Y_coord) + ";" + z.text)


print(" - ENDE CSV - ")